<?php

class SearchForm {
	
	//---------------------------------------------------------
	//  コントロール設定
	//---------------------------------------------------------
	
	public static function control() {
		
		// コントロール設定を返す
		return array(true, false, 'Header', 'Footer');
		
	}
	
	//---------------------------------------------------------
	//  詳細検索フォーム生成
	//---------------------------------------------------------
	
	public static function execute() {
		
		// DBクラスを取得
		$db = $GLOBALS['object']['db'];
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// DBのサフィックスを取得
		$suffix = $GLOBALS['suffix'];
		
		////////////////////////////////////////////////////////////
		
		// モード名を取得
		$act = $GLOBALS['args']['act'];
		
		// 年を取得
		$y = $GLOBALS['args']['y'];
		
		// 月を取得
		$m = $GLOBALS['args']['m'];
		
		////////////////////////////////////////////////////////////
		
		// テーブル名を取得
		$paramTable = $GLOBALS['config']['table']['param'];
		
		// インデントタブを設定
		$tab = "\n\t\t\t\t\t\t\t\t\t\t";
		
		// DB名を設定
		$atDB = 'access_' . $y . '_' . $m . $suffix;
		
		// DBが存在しない時は終了
		if (!$db->exists($atDB)) {
			return;
		}
		
		// DBに接続
		$db->attach($atDB);
		
		////////////////////////////////////////////////////////////
		
		// ヘッダー、メイン、フッター テンプレートを取得
		list($head, $body, $foot) = $tmpl->read('search_form.htm');
		
		// URLルートを設定
		$headVars['root'] = ROOT;
		
		// テンプレートを出力
		$tmpl->show($head, $headVars);
		
		// 端末機種の愛称を取得
		$devices = parse_ini_file(WORK_DIR . '/templates/ini/device.ini');
		
		// 項目名配列を設定
		$params = array('page', 'referrer', 'click', 'search_word', 'os', 'ua', 'device', 'client_size', 'display_size', 'host_domain', 'carrier', 'city');
		
		////////////////////////////////////////////////////////////
		
		// 項目別に<option>を出力するループ
		foreach ($params as $param) {
			
			// テンプレート変数
			$vars = array();
			
			// 項目名を設定
			$vars['type'] = $GLOBALS['title'][$param];
			
			// name属性を設定
			$vars['name'] = $param;
			
			// チェック用name/id属性を設定
			$vars['n_eq'] = $param . '_eq';
			$vars['n_ne'] = $param . '_ne';
			
			// 空欄<option>を設定
			$vars['option'] = $tab . '<option></option>';
			
			// SQL
			$query = '';
			
			// ページ、リンク元、リンク先の時
			if (preg_match('/referrer|page|click/', $param)) {
				
				// テーブル名を取得
				$pageTable = $GLOBALS['config']['table'][$param];
				
				// クエリーを作成
				$query = "select id, title from $paramTable, $pageTable where type = '$param' and value = id order by count desc;";
				
			}
			
			// ページ、リンク元、リンク先以外の時
			else {
				
				// クエリーを作成
				$query = "select value from $paramTable where type = '$param' order by count desc;";
				
			}
			
			// クエリーを実行
			$results = $db->query($query);
			
			// データ取得ループ
			while ($rec = $db->fetch($results)) {
				
				// タブを設定
				$vars['option'] .= $tab;
				
				// リンク元、ページの時
				if (preg_match('/referrer|page|click/', $param)) {
					$vars['option'] .= '<option value="' . $rec['id'] . '">' . $rec['title'] . '</option>';
				}
				
				// OS、端末機種の時
				elseif ($param === 'device' && isset($devices[$rec['value']])) {
					$vars['option'] .= '<option value="' . $rec['value'] . '">' . $devices[$rec['value']] . ' (' . $rec['value'] . ')</option>';
				}
				
				// それ以外の時
				else {
					$vars['option'] .= '<option>' . $rec['value'] . '</option>';
				}
				
			}
			
			// テンプレートを出力
			$tmpl->show($body, $vars);
			
		}
		
		////////////////////////////////////////////////////////////
		
		// 年を変数に設定
		$footVars['y'] = $y;
		
		// 月を変数に設定
		$footVars['m'] = $m;
		
		// テンプレートを出力
		$tmpl->show($foot, $footVars);
		
	}
	
}

