<?php

class ClientSize {
	
	//---------------------------------------------------------
	//  ディスプレイ解像度,ブラウザ表示領域取得
	//---------------------------------------------------------
	
	public static function parseSize() {
		
		// 変数を初期化
		$displaySize = '';
		$clientSize = '';
		
		// ディスプレイ解像度が存在する時
		if (isset($_GET['display_width']) && isset($_GET['display_height'])) {
			
			// ディスプレイ解像度を取得
			$displayWidth = (int) $_GET['display_width'];
			$displayHeight = (int) $_GET['display_height'];
			
			// ディスプレイ解像度を整形
			$displaySize = $displayWidth . ' x ' . $displayHeight;
			
		}
		
		// ブラウザ表示領域が存在する時
		if (isset($_GET['client_width']) && isset($_GET['client_height'])) {
			
			// ブラウザ表示領域を四捨五入して取得
			$clientWidth = self::round((int) $_GET['client_width'], $displayWidth);
			$clientHeight = self::round((int) $_GET['client_height'], $displayHeight);
			
			// ブラウザ表示領域を整形
			$clientSize = $clientWidth . ' x ' . $clientHeight;
			
		}
		
		// ディスプレイ解像度、ブラウザ表示領域を返す
		return array($displaySize, $clientSize);
		
	}
	
	//---------------------------------------------------------
	//  ブラウザ表示領域を四捨五入
	//---------------------------------------------------------
	
	private static function round($client, $display) {
		
		// 解像度より大きい時は調整
		if ($client > $display) {
			$client = $display;
		}
		
		// 下2桁目の位置を取得
		$length = strlen($client) - 2;
		
		// 2桁以下の時は「100」を返す
		if ($length < 1) {
			return 100;
		}
		
		// 下3桁目以上を取得
		$over = substr($client, 0, $length);
		
		// 下2桁を取得
		$under = substr($client, $length);
		
		// 下2桁が50以上の時は3桁目を繰り上げ
		if ($under > 49) {
			$over++;
		}
		
		// 四捨五入した数値を整形
		$client = intval($over . '00');
		
		// 解像度より大きい時は調整
		if ($client > $display) {
			$client -= 100;
		}
		
		// 四捨五入した数値を返す
		return $client;
		
	}
	
}

