
// ポップアップ表示View
var popView;

// ページ読み込み完了後にイベントを設定
if (window.addEventListener) {
	window.addEventListener('load', setEvent, {passive: false});
}

//////////////////////////////////////////////////////////////

// リンクイベントを設定
function setEvent() {
	
	// リンクの数を取得
	var lentgh = document.links.length;
	
	// リンクの数だけループ
	for (var i = 0; i < lentgh; i++) {
		
		// 要素を取得
		var node = document.links[i];
		
		// クラス名を取得
		var className = node.className;
		
		// 内部リンクの時
		if (className == 'in') {
			
			// 次へ
			continue;
			
		}
		
		// 外部リンクの時
		else if (className == 'out') {
			
			// ターゲット属性を設定
			node.target = '_blank';
			
			// 次へ
			continue;
			
		}
		
		// ポップアップの時
		else if (className == 'pop') {
			
			// マウスイベントを設定
			node.addEventListener('mouseover', showPopView, {passive: false});
			node.addEventListener('mouseout', hidePopView, {passive: false});
			
		}
		
	}
	
	// Viewを取得（Visit以外はnull）
	popView = document.getElementById('pop');
	
}

//////////////////////////////////////////////////////////////

// ポップViewを表示
function showPopView(e) {
	
	// URLを取得
	var url = this.href;
	
	// URL引数のみを切り出し
	var argsStr = url.replace(/^\S+\/route\//, "");
	
	// 引数を「/」で分割
	var args = argsStr.split('/');
	
	// ページ配列
	var pages = args[0].split('-');
	
	// 滞在時間配列
	var times = args[1].split('-');
	
	// クリック配列
	var clicks = args[2].split('-');
	
	// 表示するHTML
	var html = '';
	
	// 配列数分ループ
	for (i in pages) {
		
		// IDを取得
		var pageId = 'page' + pages[i];
		
		// タイトルをHTMLに追記
		if (titles[pageId]) {
			html += titles[pageId];
		} else {
			html += 'Undefined';
		}
		
		// 時間が存在する時
		if (times[i]) {
			html += ' &nbsp;' + times[i];
		}
		
		// 改行を追記
		html += '<br>';
		
	}
	
	// クリック配列が存在する時
	if (args[2]) {
		
		// 区切り線を追記
		html += '<hr>';
		
		// 配列数分ループ
		for (j in clicks) {
			
			// IDを取得
			var clickId = 'click' + clicks[j];
			
			// タイトルをHTMLに追記
			if (titles[clickId]) {
				html += titles[clickId];
			} else {
				html += 'Undefined';
			}
			
			// 改行を追記
			html += '<br>';
			
		}
		
	}
	
	// イベントが発生した座標を取得
	var top = (e) ? e.pageY : event.clientY + document.documentElement.scrollTop;
	var left = (e) ? e.pageX : event.clientX + document.documentElement.scrollLeft;
	
	// ViewのHTMLを設定
	popView.innerHTML = html;
	
	// Viewの位置を設定
	popView.style.top = top + 20 + 'px';
	popView.style.left = left - 60 + 'px';
	
	// Viewを表示
	popView.style.visibility = 'visible';
	
}

//////////////////////////////////////////////////////////////

// ポップViewを非表示
function hidePopView() {
	
	// Viewを非表示
	popView.style.visibility = 'hidden';
	
	// ViewのHTMLをリセット
	popView.innerHTML = '';
	
}

//////////////////////////////////////////////////////////////

// Formの送信ボタンを無効に設定（二重送信防止）
function submitDisabled(i) {
	
	// ボタンを無効に設定
	document.forms[i].submit.disabled = true;
	
	// trueを返す（送信許可）
	return true;
	
}

//////////////////////////////////////////////////////////////

// サイト切り替え
function switchSite(value) {
	
	// Dateクラスを作成
	var date = new Date();
	
	// 1年後を設定
	date.setFullYear(date.getFullYear() + 1);
	
	// Cookieを設定
	document.cookie = 'site=' + value + '; path=/; ' + 'expires=' + date.toUTCString();
	
	// ページをリロード
	location.reload();
	
}

