<?php

class Login {
	
	//---------------------------------------------------------
	//  ログイン処理
	//---------------------------------------------------------
	
	public static function execute() {
		
		// 変数を初期化
		$username = '';
		$password = '';
		
		// フォームデータが存在する時
		if (isset($_POST['login'])) {
			
			// ユーザーIDを取得
			$username = (isset($_POST['username'])) ? md5($_POST['username']) : '';
			
			// パスワードを取得
			$password = (isset($_POST['password'])) ? md5($_POST['password']) : '';
			
		}
		
		// Cookieが存在する時
		elseif (isset($_COOKIE['lunalysLogin'])) {
			
			// Cookieをパース
			parse_str($_COOKIE['lunalysLogin'], $results);
			
			// ユーザーIDを取得
			$username = (isset($results['username'])) ? $results['username'] : '';
			
			// パスワードを取得
			$password = (isset($results['password'])) ? $results['password'] : '';
			
		}
		
		// ユーザーIDもしくはパスワードが一致しない時はログインフォームを表示
		if ($username !== md5($GLOBALS['config']['login']['username']) || $password !== md5($GLOBALS['config']['login']['password'])) {
			exit(self::showForm());
		}
		
		// Cookieの有効期限を設定
		$time = $_SERVER['REQUEST_TIME'] + (60 * 60 * 24 * 365);
		
		// 現在のホストドメインを取得
		$host = $_SERVER['SERVER_NAME'];
		
		// Cookieを発行
		setcookie('lunalysLogin', "username=$username&password=$password", $time, '/', $host);
		
	}
	
	//---------------------------------------------------------
	//  ログインフォーム表示
	//---------------------------------------------------------
	
	private static function showForm() {
		
		// テンプレートクラスを取得
		$tmpl = $GLOBALS['object']['tmpl'];
		
		// テンプレートを読み込み
		$html = $tmpl->read('login.htm', false);
		
		// URLルートを設定
		$vars['root'] = ROOT;
		
		// URLルートディレクトリを設定
		$vars['rootDir'] = ROOT_DIR;
		
		// ユーザー名に空欄を設定
		$vars['username'] = '';
		
		// パスワードに空欄を設定
		$vars['password'] = '';
		
		// テンプレートを出力
		$tmpl->show($html, $vars);
		
	}
	
}

